import QtQuick
import QtQuick3D
import QtQuick 2.15
import Quick3DAssets.Demo_City_Buildings_version5 1.0
Node {
    id: rootNode
    property bool night: false
    y: 500

    Model {
        id: demo_City_Buildings
        opacity: 1
        visible: true
        scale.x: 1.37
        scale.y: 1
        scale.z: 1
        source: "../Demo_City_Buildings_version5/meshes/demo_City_Buildings_v5.mesh"
        eulerRotation.z: 0
        eulerRotation.y: 0
        eulerRotation.x: 0
        pickable: false
        castsShadows: false
        receivesShadows: false
        materials: defaultMaterial
        depthBias: 1

        DefaultMaterial {
            id: defaultMaterial
            opacity: 1
            opacityMap: city_diff_alpha
            diffuseMap: city_diff
            diffuseLightWrap: 0
            opacityChannel: Material.A
            vertexColorsEnabled: false
            translucencyChannel: Material.R
            cullMode: Material.NoCulling
            blendMode: DefaultMaterial.SourceOver
            specularRoughness: 1
            indexOfRefraction: 3
            specularAmount: 1
            specularTint: "#ccccea"
            depthDrawMode: Material.AlwaysDepthDraw
            diffuseColor: "#f9e0e0"

            Texture {
                id: city_diff
                source: "../../../images/city_diff.png"
                minFilter: Texture.Nearest
                magFilter: Texture.Nearest
                mipFilter: Texture.Nearest
                generateMipmaps: true
            }

            Texture {
                id: city_diff_alpha
                source: "../../../images/city_diff_alpha.png"
                minFilter: Texture.Nearest
                magFilter: Texture.Nearest
                mipFilter: Texture.Nearest
                generateMipmaps: true
            }
        }
    }

    Model {
        id: demo_City_Buildings1
        x: -0
        y: 0
        opacity: 1
        visible: true
        source: "../Demo_City_Buildings_version5/meshes/demo_City_Buildings_shadow5.mesh"
        eulerRotation.z: 0
        eulerRotation.y: 0
        eulerRotation.x: 0
        pickable: false
        castsShadows: false
        receivesShadows: false
        z: 0.00065
        scale.y: 1
        materials: defaultMaterial1
        depthBias: 1
        DefaultMaterial {
            id: defaultMaterial1
            opacity: 1
            opacityChannel: Material.B
            opacityMap: city_diff1
            diffuseMap: city_diff1
            lighting: DefaultMaterial.FragmentLighting


            Texture {
                id: city_diff1
                source: "../../../images/city_effects.png"
                magFilter: Texture.Nearest
                minFilter: Texture.Nearest
                mipFilter: Texture.Nearest
                generateMipmaps: true
            }
            diffuseColor: "#eaeaea"
            indexOfRefraction: 3
            depthDrawMode: Material.AlwaysDepthDraw
            specularAmount: 1
            cullMode: Material.NoCulling
            blendMode: DefaultMaterial.SourceOver
            specularTint: "#aaaac0"
            specularRoughness: 1
            translucencyChannel: Material.R
        }
        scale.x: 1.37
        scale.z: 1
    }

    Demo_City_Buildings_version5 {
        id: demo_City_Buildings_version5
        visible: false
        scale.z: 1
        scale.y: 1
        scale.x: 1.37477
    }
    states: [
        State {
            name: "day"
            when: !globalNightMode

            PropertyChanges {
                target: defaultMaterial
                opacity: 1
                depthDrawMode: Material.AlwaysDepthDraw
            }

            PropertyChanges {
                target: demo_City_Buildings1
                opacity: 1
                castsShadows: false
                receivesShadows: false
            }

            PropertyChanges {
                target: defaultMaterial1
                opacity: 1
                cullMode: Material.NoCulling
                depthDrawMode: Material.AlwaysDepthDraw
            }

            PropertyChanges {
                target: demo_City_Buildings
                castsShadows: false
            }
        },
        State {
            name: "night"
            when: globalNightMode

            PropertyChanges {
                target: defaultMaterial1
                opacity: 1
                depthDrawMode: Material.AlwaysDepthDraw
                blendMode: DefaultMaterial.SourceOver
                diffuseColor: "#10175b"
            }

            PropertyChanges {
                target: defaultMaterial
                indexOfRefraction: 1
                specularAmount: 1
                emissiveFactor: "0"
                specularTint: "#2d0e4f"
                diffuseColor: "#201a52"
            }

            PropertyChanges {
                target: demo_City_Buildings1
                opacity: 1
                scale.z: 0.94625
                z: 0.00063
                scale.x: 1.37
                receivesShadows: false
                castsShadows: false
            }

            PropertyChanges {
                target: demo_City_Buildings_version5
                visible: false
            }

            PropertyChanges {
                target: demo_City_Buildings
                x: 0
                y: 0
                scale.z: 0.94625
                z: 0.00002
                scale.x: 1.37
            }
        }
    ]
    transitions: [
        Transition {
            id: transition
            ParallelAnimation {
                SequentialAnimation {
                    PauseAnimation {
                        duration: 13
                    }

                    PropertyAnimation {
                        target: defaultMaterial
                        property: "opacity"
                        duration: 1891
                    }
                }

                SequentialAnimation {
                    PauseAnimation {
                        duration: 13
                    }

                    PropertyAnimation {
                        target: defaultMaterial
                        property: "specularTint"
                        duration: 1891
                    }
                }

                SequentialAnimation {
                    PauseAnimation {
                        duration: 13
                    }

                    PropertyAnimation {
                        target: defaultMaterial
                        property: "diffuseColor"
                        duration: 1891
                    }
                }
            }

            ParallelAnimation {
                SequentialAnimation {
                    PauseAnimation {
                        duration: 13
                    }

                    PropertyAnimation {
                        target: demo_City_Buildings1
                        property: "opacity"
                        duration: 1891
                    }
                }
            }

            ParallelAnimation {
                SequentialAnimation {
                    PauseAnimation {
                        duration: 13
                    }

                    PropertyAnimation {
                        target: defaultMaterial1
                        property: "diffuseColor"
                        duration: 1891
                    }
                }

                SequentialAnimation {
                    PauseAnimation {
                        duration: 13
                    }

                    PropertyAnimation {
                        target: defaultMaterial1
                        property: "opacity"
                        duration: 1891
                    }
                }
            }
            to: "*"
            from: "*"
        }
    ]


}






